#include <bits/stdc++.h>

using namespace std;

int lis(const vector<int>& v) {
    if(v.size() == 0) return 0;

    vector<int> tail;       // last element of each LIS
    tail.push_back(v[0]);   // start with the first element
    for(int i = 1; i < v.size(); i++) {
        if(v[i] > tail.back()) tail.push_back(v[i]);                // clone and extend
        else *lower_bound(tail.begin(), tail.end(), v[i]) = v[i];   // clone, extend and discard
    }

    return tail.size();
}

int main() {
    cout << lis({0, 8, 4, 12, 2, 10, 6, 14, 1, 9, 5, 13, 3, 11, 7, 15}) << endl;
    return 0;
}  
